import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
export var Buffer = /*#__PURE__*/function () {
  function Buffer(bindingPoint, length) {
    _classCallCheck(this, Buffer);

    this.cursor = 0;
    this.buffer = void 0;
    this.bindingPoint = void 0;
    this.i32 = void 0;
    this.f32 = void 0;
    // we only use Int32 and Float32, so 4 bytes for each item
    this.buffer = new ArrayBuffer(length * 4);
    this.i32 = new Int32Array(this.buffer);
    this.f32 = new Float32Array(this.buffer);
    this.bindingPoint = bindingPoint;
  } // createWebGLBuffer(gl: WebGL2Context) {
  //   const id = gl.createBuffer();
  //   gl.bindBuffer(gl.SHADER_STORAGE_BUFFER, id);
  //   // Important! Tell the buffer to bind to a specific binding point
  //   gl.bindBufferBase(gl.SHADER_STORAGE_BUFFER, this.bindingPoint, id);
  //   return {
  //     name,
  //     buffer: id as WebGLBuffer,
  //     length: 0,
  //   };
  // }


  _createClass(Buffer, [{
    key: "appendF",
    value: function appendF(n) {
      this.f32[this.cursor++] = n;
    }
  }, {
    key: "appendI",
    value: function appendI(n) {
      this.i32[this.cursor++] = n;
    }
  }, {
    key: "pad",
    value: function pad(n) {
      this.cursor += n;
    }
  }]);

  return Buffer;
}();
//# sourceMappingURL=Buffer.js.map