"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MeshBuffer = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _Buffer2 = require("./Buffer");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var MeshBuffer = /*#__PURE__*/function (_Buffer) {
  (0, _inherits2.default)(MeshBuffer, _Buffer);

  var _super = _createSuper(MeshBuffer);

  function MeshBuffer(length) {
    (0, _classCallCheck2.default)(this, MeshBuffer);
    return _super.call(this, 2, length);
  }

  (0, _createClass2.default)(MeshBuffer, [{
    key: "append",
    value: function append(meshData) {
      var _meshData$slabCount, _meshData$slabOffset, _meshData$specularExp;

      // padding required: https://twitter.com/9ballsyndrome/status/1178039885090848770
      // under std430 layout, a struct in an array use the largest alignment of its member.
      // int face_count;
      this.appendI(meshData.faceCount); // int offset;

      this.appendI(meshData.vertexOffset); // int slab_count

      this.appendI((_meshData$slabCount = meshData.slabCount) !== null && _meshData$slabCount !== void 0 ? _meshData$slabCount : 0); // int slab_offset;

      this.appendI((_meshData$slabOffset = meshData.slabOffset) !== null && _meshData$slabOffset !== void 0 ? _meshData$slabOffset : 0); // alpha

      this.appendF((_meshData$specularExp = meshData.specularExponent) !== null && _meshData$specularExp !== void 0 ? _meshData$specularExp : 100); // paddings

      this.pad(3); // vec3 color;

      this.appendF(meshData.diffuseColor[0] || 0);
      this.appendF(meshData.diffuseColor[1] || 0);
      this.appendF(meshData.diffuseColor[2] || 0); // padding

      this.pad(1); // vec3 specular

      this.appendF(meshData.specularColor[0] || 0);
      this.appendF(meshData.specularColor[1] || 0);
      this.appendF(meshData.specularColor[2] || 0); // padding

      this.pad(1); // vec3 refraction;

      this.appendF(meshData.refractionColor[0] || 0);
      this.appendF(meshData.refractionColor[1] || 0);
      this.appendF(meshData.refractionColor[2] || 0); // padding

      this.pad(1);
    }
  }]);
  return MeshBuffer;
}(_Buffer2.Buffer);

exports.MeshBuffer = MeshBuffer;
MeshBuffer.bytes = 20;
//# sourceMappingURL=MeshBuffer.js.map